/**
 * Copyright (C) 2022 Xilinx, Inc
 * Copyright (C) 2022 Advanced Micro Devices, Inc. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"). You may
 * not use this file except in compliance with the License. A copy of the
 * License is located at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

#pragma once

// Include files
// Please keep these to the bare minimum
#include "Report.h"

#include <string>
#include <vector>
#include <utility> // Pair template
#include <boost/program_options.hpp>
#include <boost/property_tree/ptree.hpp>

namespace XBUtilities {

using VectorPairStrings = std::vector<std::pair<std::string, std::string>>;

std::string create_suboption_list_string(const VectorPairStrings& _collection);

std::string create_suboption_list_string(const ReportCollection& _reportCollection, bool _addAllOption);

std::string create_suboption_list_string(const Report::SchemaDescriptionVector& _formatCollection);

void collect_and_validate_reports(const ReportCollection& allReportsAvailable, const std::vector<std::string>& reportNamesToAdd, ReportCollection& reportsToUse);

void produce_reports(
    DeviceCollection& devices, const ReportCollection& reportsToProcess, Report::SchemaVersion schema, std::ostream& consoleStream, std::ostream& schemaStream);
}; // namespace XBUtilities
